<?php  

class mabnapayment extends PaymentModule{  

	private $_html = '';
	private $_postErrors = array();

	public function __construct(){  

		$this->name = 'mabnapayment';  
		$this->tab = 'payments_gateways';  
		$this->version = '1.0';  
		$this->author = 'www.softiran.org';
		
		$this->currencies = true;
  		$this->currencies_mode = 'radio';
		
		parent::__construct();  		
		
		$this->page = basename(__FILE__, '.php');
		$this->displayName = $this->l('درگاه شرکت مبنا کارت');  
		$this->description = $this->l('ساخته شده توسط سافت ایران به سفارش مبنا کارت');  
		$this->confirmUninstall = $this->l('شما از حذف این ماژول مطمئن هستید ؟');

		if (!sizeof(Currency::checkPaymentCurrencies($this->id)))
			$this->warning = $this->l('ارز تنظیم نشده است');

		$config = Configuration::getMultiple(array('MABNA_PIN', ''));			
		if (!isset($config['MABNA_PIN']))
			$this->warning = $this->l('شما باید مرچنت درگاه را وارد کنید');	
		$config = Configuration::getMultiple(array('MABNA_TER', ''));			
		if (!isset($config['MABNA_TER']))
			$this->warning = $this->l('شما باید ترمینال درگاه را وارد کنید');
			
		if ($_SERVER['SERVER_NAME'] == 'localhost')
			$this->warning = $this->l('این ماژول روی لوکال کار نمیکند');


	}  
	public function install(){
		if (!parent::install()
	    	OR !Configuration::updateValue('MABNA_PIN', '')
	    	OR !Configuration::updateValue('MABNA_HASHKEY', '')
	    	OR !Configuration::updateValue('MABNA_TER', '')
	      	OR !$this->registerHook('payment')
	      	OR !$this->registerHook('paymentReturn')){
			    return false;
		}else{
		    return true;
		}
	}
	public function uninstall(){
		if (!Configuration::deleteByName('MABNA_PIN') 
			OR !Configuration::deleteByName('MABNA_HASHKEY') 
			OR !Configuration::deleteByName('MABNA_TER') 
			OR !parent::uninstall())
			return false;
		return true;
	}
	
	public function displayFormSettings()
	{
		$bank_id = Configuration::get('MABNA_HASHKEY');
		
		$this->_html .= '
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
			<fieldset>
				<legend><img src="../img/admin/cog.gif" alt="" class="middle" />'.$this->l('Settings').'</legend>
				<label>'.$this->l('شناسه درگاه').'</label>
				<div class="margin-form"><input type="text" size="30" name="MABNAPIN" value="'.Configuration::get('MABNA_PIN').'" /></div>
				<label>'.$this->l('ترمینال درگاه').'</label>
				<div class="margin-form"><input type="text" size="30" name="MABNA_TER" value="'.Configuration::get('MABNA_TER').'" /></div>
				
				<p class="hint clear" style="display: block; width: 501px;"><a href="http://www.softiran.org" target="_blank" >'.$this->l('ساخته شده توسط گروه برنامه نویسی سافت ایران').'</a></p></div>
				<center><input type="submit" name="submitMABNA" value="'.$this->l('به روز رسانی تنظیمات').'" class="button" /></center>			
			</fieldset>
		</form>';
	}

	public function displayConf()
	{
		$this->_html .= '
		<div class="conf confirm">
			<img src="../img/admin/ok.gif" alt="'.$this->l('Confirmation').'" />
			'.$this->l('Settings updated').'
		</div>';
	}
	
	public function displayErrors()
	{
		foreach ($this->_postErrors AS $err)
		$this->_html .= '<div class="alert error">'. $err .'</div>';
	}

       	public function getContent()
	{
		$this->_html = '<h2>'.$this->l('mabnapayment').'</h2>';
		if (isset($_POST['submitMABNA']))
		{
			if (empty($_POST['MABNAPIN']))
				$this->_postErrors[] = $this->l('مرچنت را وارد کنید');
			if (empty($_POST['MABNA_TER']))
				$this->_postErrors[] = $this->l('ترمینال را وارد کنید');
			if (empty($_POST['HashKey']))
				 $_POST['HashKey'] = '0';
			if (!sizeof($this->_postErrors))
			{
				Configuration::updateValue('MABNA_PIN', $_POST['MABNAPIN']);
				Configuration::updateValue('MABNA_HASHKEY', $_POST['HashKey']);
				Configuration::updateValue('MABNA_TER', $_POST['MABNA_TER']);
				$this->displayConf();
			}
			else
				$this->displayErrors();
		}

		$this->displayFormSettings();
		return $this->_html;
	}

	private function displayIrankishPayment()
	{
		$this->_html .= '<img src="../modules/mabnapayment/mabnapayment.png" style="float:left; margin-right:15px;"><b>'.$this->l('این ماژول امکان واریز آنلاین توسط درگاه شرکت مبنا کارت را مهیا می سازد').'</b><br /><br />
		'.$this->l('تمامی کارت های عضو شتاب').'<br /><br /><br />';

	}

	public function execPayment($cart)
	{
		global $cookie, $smarty;
	
		$purchase_currency = new Currency(Currency::getIdByIsoCode('IRR'));			
		$OrderDesc = Configuration::get('PS_SHOP_NAME'). $this->l(' Order');
		$current_currency = new Currency($this->context->cookie->id_currency);
		if($current_currency->id == $purchase_currency->id)
			$PurchaseAmount= number_format($cart->getOrderTotal(true, 3), 0, '', '');		 
		else
			$PurchaseAmount= number_format(Tools::convertPrice($cart->getOrderTotal(true, 3), $purchase_currency), 0, '', '');	 

		$merchant = trim(Configuration::get('MABNA_PIN'));			
		$terminal = trim(Configuration::get('MABNA_TER'));			
		$OrderId = $cart->id;
		
		$amount = trim($PurchaseAmount);
		$redirectAddress = (Configuration::get('PS_SSL_ENABLED') ?'https://' :'http://').$_SERVER['HTTP_HOST'].__PS_BASE_URI__.'modules/mabnapayment/validation.php?paid='.$OrderId;
		$invoiceNumber = time();

		$source = $amount . $invoiceNumber . $merchant . $redirectAddress . $terminal;
		$pat = dirname(__FILE__);
		$fp = fopen($pat . '/public.txt', "r");
		$pub_key = fread($fp, 8192);
		fclose($fp);
		if (strpos($pub_key, '-----BEGIN PUBLIC KEY-----') === false)
			$pub_key = "-----BEGIN PUBLIC KEY-----\n" . $pub_key;

		if (strpos($pub_key, '-----END PUBLIC KEY-----') === false)
			$pub_key .= "\n-----END PUBLIC KEY-----";


		// Amount
		$key_resource = openssl_get_publickey($pub_key);

		openssl_public_encrypt($amount, $crypttext, $key_resource);

		$Amount = base64_encode($crypttext);
		// CRN

		openssl_public_encrypt($invoiceNumber, $crypttext, $key_resource);
		$CRN = base64_encode($crypttext);

		// MID
		openssl_public_encrypt($merchant, $crypttext, $key_resource);
		$MID = base64_encode($crypttext);

		// TID
		openssl_public_encrypt($terminal, $crypttext, $key_resource);
		$TID = base64_encode($crypttext);

		// redirectAddress
		openssl_public_encrypt($redirectAddress, $crypttext, $key_resource);
		$referal = base64_encode($crypttext);

		$key = file_get_contents($pat . '/private.txt');

		if (strpos($key, '-----BEGIN PRIVATE KEY-----') === false)
			$key = "-----BEGIN PRIVATE KEY-----\n" . $key;

		if (strpos($key, '-----END PRIVATE KEY-----') === false)
			$key .= "\n-----END PRIVATE KEY-----";

		$priv_key = openssl_pkey_get_private($key);
		$signature = '';
		openssl_sign($source, $signature, $priv_key, OPENSSL_ALGO_SHA1);
		$inputArray = array("Token_param" => array("AMOUNT" => $Amount,
			"CRN" => $CRN,
			"MID" => $MID,
			"REFERALADRESS" => $referal,
			"SIGNATURE" => base64_encode($signature),
			"TID" => $TID,
		));

	   if(!function_exists('timestamp_to_iso8601'))
		{
			include_once($pat . '/nusoap.php');
		}
		
		$__SOAP = "https://mabna.shaparak.ir/TokenService?wsdl";
		$client = new nusoap_client($__SOAP, 'wsdl');
		$WSResult = $client->call("reservation", $inputArray);
		$signature = base64_decode($WSResult['return']['signature']);
		$ok = openssl_verify($WSResult['return']['token'], $signature, $key_resource);
		openssl_free_key($key_resource);
		if ($ok == 1 && $WSResult['return']['result'] == 0) 
		{
				return	'
		<form id="redirectpost" method="post" action="https://mabna.shaparak.ir">
			<input type="hidden" name="TOKEN" value="'.$WSResult['return']['token'].'"> 
			</form> <script language="javascript"> document.getElementById("redirectpost").submit(); </script>';
		}else
		{
			echo $this->error($this->l('خطا در ساخت توکن') . ' (' . $WSResult['return']['token'] . ')');
		}

	}
	public function confirmPayment($order_amount,$Status,$Refnumber)
	{
		
	}
		
	public function showMessages($result)
	{                

	}	
		public function error($str) {
		return '<div class="alert alert-danger" style="text-align: center;font-family: Tahoma;"> ' . $str . '</div>';
	}
	public function hookPayment($params){

		if (!$this->active)
			return ;
		
		return $this->display(__FILE__, 'payment.tpl');
	}
	
	public function hookPaymentReturn($params)
	{
		if (!$this->active)
		       return ;

		return $this->display(__FILE__, 'confirmation.tpl');
	}

}