<?php

include(dirname(__FILE__).'/../../config/config.inc.php');
include(dirname(__FILE__).'/../../header.php');
include_once(dirname(__FILE__).'/mabnapayment.php');

if (!$cookie->isLogged())
	Tools::redirect('authentication.php?back=order.php');     
$currency_default = Currency::getCurrency(intval(Configuration::get('PS_CURRENCY_DEFAULT')));        
$mabnapayment= new mabnapayment(); // Create an object for order validation and language translations
@session_start();

$paymentId = isset($_GET["paid"]) ? $_GET['paid'] : 0;

$order_cart = new Cart(intval($paymentId));

$purchase_currency = new Currency(Currency::getIdByIsoCode('IRR'));		
$current_currency = new Currency(Context::getContext()->cookie->id_currency);
if($current_currency->id==$purchase_currency->id)
	$PurchaseAmount= number_format($cart->getOrderTotal(true, 3), 0, '', '');		 
else
	$PurchaseAmount= number_format(Tools::convertPrice($cart->getOrderTotal(true, 3), $purchase_currency), 0, '', '');

if( isset($_POST['CRN']) && isset($_POST['TRN']) && isset($_POST['RESCODE']) && $_POST['RESCODE'] == '00' )
{
	
	$merchant =trim(Configuration::get('MABNA_PIN'));
	$pat = dirname(__FILE__);
	if(!function_exists('timestamp_to_iso8601'))
	{
		include_once($pat . '/nusoap.php');
	}
	$client = new nusoap_client("https://mabna.shaparak.ir/TransactionReference/TransactionReference?wsdl", 'wsdl');
	$error = $client->getError();
	
	$fp = fopen($pat . '/public.txt', "r");
	$pub_key = fread($fp, 8192);
	fclose($fp);
	if (strpos($pub_key, '-----BEGIN PUBLIC KEY-----') === false)
		$pub_key = "-----BEGIN PUBLIC KEY-----\n" . $pub_key;

	if (strpos($pub_key, '-----END PUBLIC KEY-----') === false)
		$pub_key .= "\n-----END PUBLIC KEY-----";

	$key_resource = openssl_get_publickey($pub_key);

	openssl_public_encrypt($_POST["TRN"], $crypttext, $key_resource );
	$TRN = base64_encode($crypttext);

	// CRN
	openssl_public_encrypt($_POST["CRN"], $crypttext, $key_resource );
	$CRN = base64_encode($crypttext);

	// MID
	openssl_public_encrypt($merchant, $crypttext, $key_resource );
	$MID = base64_encode($crypttext);

	// Sign data
	$source = $merchant.$_POST["TRN"].$_POST["CRN"];
	
	$key = file_get_contents($pat . '/private.txt');

	if (strpos($key, '-----BEGIN PRIVATE KEY-----') === false)
		$key = "-----BEGIN PRIVATE KEY-----\n" . $key;

	if (strpos($key, '-----END PRIVATE KEY-----') === false)
		$key .= "\n-----END PRIVATE KEY-----";

	$priv_key = openssl_pkey_get_private($key);
	$signature = '';
	openssl_sign($source, $signature, $priv_key, OPENSSL_ALGO_SHA1);
	$inputArray = array("SaleConf_req" => array("MID"    => $MID,
												"CRN"    => $CRN,
												"TRN"    => $TRN,
												"SIGNATURE" => base64_encode($signature)));
	$WSResult = $client->call("sendConfirmation", $inputArray);
	$error = $client->getError();
	$signature = base64_decode($WSResult["return"]["SIGNATURE"]);
	$data      = $WSResult["return"]["RESCODE"].$WSResult["return"]["REPETETIVE"].$WSResult["return"]["AMOUNT"].$WSResult["return"]["DATE"].$WSResult["return"]["TIME"].$WSResult["return"]["TRN"].$WSResult["return"]["STAN"];
	$ok = openssl_verify($data, $signature, $key_resource);
	if ($ok == 1) 
	{
		 if (($WSResult['return']['RESCODE'] == '00') && ($WSResult['return']['successful'] == true)) 
		 {
			if( floatval($WSResult["return"]["AMOUNT"]) == floatval($PurchaseAmount) )
			{
				$referenceId = $WSResult["return"]["TRN"];
				$paid = $mabnapayment->validateOrder((int)$paymentId, _PS_OS_PAYMENT_, (float)Context::getContext()->cart->getOrderTotal(true, 3), $mabnapayment->displayName, "سفارش تایید شده / کد رهگیری :".$referenceId , array(),(int)Context::getContext()->currency->id, false);			
				Tools::redirect('index.php?controller=history');
			}
			else
			{
				echo $mabnapayment->error($mabnapayment->l('مبلغ واریزی با قیمت محصول برابر نیست'));
			}
		 }
		else
		{
			echo $mabnapayment->error($mabnapayment->l('قبلا پرداخت تکمیل شده است.'));
		}
	}else
	{
		echo $mabnapayment->error($mabnapayment->l('خطا در وریفای اطلاعات.'));
	}
}
else
{
	$err = 'برگشت ناموفق از درگاه';
	echo $mabnapayment->error($mabnapayment->l($err));
}
include_once(dirname(__FILE__).'/../../footer.php');		

?>